Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# ConnectionManager Class Reference

The primary interface to the low-level networking layer in this package. More...

Inheritance diagram for ConnectionManager:

List of all members.

## Public Member Functions
| ConnectionManager ()
bool | closeConnection (Connection connection)
| Terminates a UDP or TCP socket previously opened.
Connection | openTCPClientConnection (string hostname, int port, int timeout_ms)
| This is a shorthand version of the function to directly establish communications to a named host and port.
Connection | openTCPClientConnection (NetAddress const address, int timeout_ms)
| Attempts to establish a TCP client connection to a server at the indicated address.
Connection | openTCPServerRendezvous (NetAddress const address, int backlog)
| Creates a socket to be used as a rendezvous socket for a server to listen for TCP connections.
Connection | openTCPServerRendezvous (string hostname, int port, int backlog)
| Creates a socket to be used as a rendezvous socket for a server to listen for TCP connections.
Connection | openTCPServerRendezvous (int port, int backlog)
| Creates a socket to be used as a rendezvous socket for a server to listen for TCP connections.
Connection | openUDPConnection (int port)
| Opens a socket for sending and/or receiving UDP packets.
Connection | openUDPConnection ()
| Opens a socket for sending and/or receiving UDP packets.
bool | waitForReaders (double timeout)
| Blocks the process for timeout number of seconds, or until any data is available on any of the non-threaded ConnectionReaders or ConnectionListeners, whichever comes first.
## Static Public Member Functions
static string | getHostName ()
| Returns the name of this particular machine on the network, if available, or the empty string if the hostname cannot be determined.

## Detailed Description

The primary interface to the low-level networking layer in this package.

A ConnectionManager is used to establish and destroy TCP and UDP connections. Communication on these connections, once established, is handled via ConnectionReader, ConnectionWriter, and ConnectionListener.

You may use this class directly if you don't care about tracking which connections have been unexpectedly closed; otherwise, you should use QueuedConnectionManager to get reports about these events (or derive your own class to handle these events properly).

## Constructor & Destructor Documentation

ConnectionManager | ( |  | ) |

## Member Function Documentation

bool closeConnection | ( | Connection | connection | ) |

Terminates a UDP or TCP socket previously opened.

This also removes it from any associated ConnectionReader or ConnectionListeners.

The socket itself may not be immediately closed--it will not be closed until all outstanding pointers to it are cleared, including any pointers remaining in NetDatagrams recently received from the socket.

The return value is true if the connection was marked to be closed, or false if close_connection() had already been called (or the connection did not belong to this ConnectionManager). In neither case can you infer anything about whether the connection has actually* been closed yet based on the return value.

static string getHostName | ( |  | ) | `[static]`

Returns the name of this particular machine on the network, if available, or the empty string if the hostname cannot be determined.

Connection openTCPClientConnection | ( | NetAddress const | address,
|  | int | timeout_ms
| ) |  |

Attempts to establish a TCP client connection to a server at the indicated address.

If the connection is not established within timeout_ms milliseconds, a null connection is returned.

Connection openTCPClientConnection | ( | string | hostname,
|  | int | port,
|  | int | timeout_ms
| ) |  |

This is a shorthand version of the function to directly establish communications to a named host and port.

Connection openTCPServerRendezvous | ( | string | hostname,
|  | int | port,
|  | int | backlog
| ) |  |

Creates a socket to be used as a rendezvous socket for a server to listen for TCP connections.

The socket returned by this call should only be added to a ConnectionListener (not to a generic ConnectionReader).

This variant of this method accepts a "hostname", which is usually just an IP address in dotted notation, and a port number. It will listen on the interface indicated by the IP address. If the IP address is empty string, it will listen on all interfaces.

backlog is the maximum length of the queue of pending connections.

Connection openTCPServerRendezvous | ( | int | port,
|  | int | backlog
| ) |  |

Creates a socket to be used as a rendezvous socket for a server to listen for TCP connections.

The socket returned by this call should only be added to a ConnectionListener (not to a generic ConnectionReader).

This variant of this method accepts a single port, and will listen to that port on all available interfaces.

backlog is the maximum length of the queue of pending connections.

Connection openTCPServerRendezvous | ( | NetAddress const | address,
|  | int | backlog
| ) |  |

Creates a socket to be used as a rendezvous socket for a server to listen for TCP connections.

The socket returned by this call should only be added to a ConnectionListener (not to a generic ConnectionReader).

This variant of this method accepts a NetAddress, which allows you to specify a specific interface to listen to.

backlog is the maximum length of the queue of pending connections.

Connection openUDPConnection | ( |  | ) |

Opens a socket for sending and/or receiving UDP packets.

If the port number is greater than zero, the UDP connection will be opened for listening on the indicated port; otherwise, it will be useful only for sending.

Use a ConnectionReader and ConnectionWriter to handle the actual communication.

Connection openUDPConnection | ( | int | port | ) |

Opens a socket for sending and/or receiving UDP packets.

If the port number is greater than zero, the UDP connection will be opened for listening on the indicated port; otherwise, it will be useful only for sending.

Use a ConnectionReader and ConnectionWriter to handle the actual communication.

bool waitForReaders | ( | double | timeout | ) |

Blocks the process for timeout number of seconds, or until any data is available on any of the non-threaded ConnectionReaders or ConnectionListeners, whichever comes first.

The return value is true if there is data available (but you have to iterate through all readers to find it), or false if the timeout occurred without any data.

If the timeout value is negative, this will block forever or until data is available.

This only works if all ConnectionReaders and ConnectionListeners are non-threaded. If any threaded ConnectionReaders are part of the ConnectionManager, the timeout value is implicitly treated as 0.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties